<?php

defined('JPATH_PLATFORM') or die;
jimport('joomla.form.formfieldlist');

class JFormFieldColorschemelist extends JFormFieldList
{
    /**
     * The form field type.
     *
     * @var    string
     * @since  11.3
     */
    protected $type = 'Color';

    /**
     * Method to get the field input markup.
     *
     * @return  string  The field input markup.
     *
     * @since   11.3
     */
    protected function getInput()
    {

        $colors = array();
        //default style
        $colors['default_scheme'] = array(
            'conf_background' =>'#E0DFE4',
            'conf_main_color' => '#F1F6CE',
            'conf_title_color' => '#E7F1B2',
            'conf_border_color' => '#999999',
            'conf_title_font_color' => '#798730',
            'conf_files_font_color' => '#E0DFE4',
            'conf_toolbar_color' => '#666666');
        //citrus cocktail
        $colors['citrus_cocktail'] = array(
            'conf_background' =>'#FFF799',
            'conf_main_color' =>'#FFE96B',
            'conf_title_color' => '#FFBE52',
            'conf_border_color' =>'#25004A',
            'conf_title_font_color' => '#25004A',
            'conf_files_font_color' => '#DE73FF',
            'conf_toolbar_color' => '#DE73FF');
        //Blues'n lime
        $colors['blues_lime'] = array(
            'conf_background' =>'#E3E3E3',
            'conf_main_color' =>'#7E8AA2',
            'conf_title_color' =>'#263248',
            'conf_border_color' => '#OA111F',
            'conf_title_font_color' => '#B8CC00',
            'conf_files_font_color' => '#E3E3E3',
            'conf_toolbar_color' => '#B8CC00');
        //Blue smoke
        $colors['blue_smoke'] = array(
            'conf_background' =>'#EFEFEF',
            'conf_main_color' =>'#E4E4E4',
            'conf_title_color' =>'#BFC5CE',
            'conf_border_color' => '#9D9D9D',
            'conf_title_font_color' => '#4679C5',
            'conf_files_font_color' => '#B1CEF9',
            'conf_toolbar_color' => '#7E8795');
        //Timber breeze
        $colors['timber_breeze'] = array(
            'conf_background' =>'#F8F3A1',
            'conf_main_color' =>'#EBCD54',
            'conf_title_color' =>'#BFAB52',
            'conf_border_color' => '#2E3C1B',
            'conf_title_font_color' => '#F8F3A1',
            'conf_files_font_color' => '#9EBA49',
            'conf_toolbar_color' => '#877318');
        //Purple
        $colors['purple'] = array(
            'conf_background' =>'#E4EDF9',
            'conf_main_color' =>'#F2D3F6',
            'conf_title_color' =>'#E7BDE5',
            'conf_border_color' => '#D57EBC',
            'conf_title_font_color' => '#AE20A2',
            'conf_files_font_color' => '#E4EDF9',
            'conf_toolbar_color' => '#6E6FBD');
        //Banana flambe
        $colors['banano_flambe'] = array(
            'conf_background' =>'#FCD876',
            'conf_main_color' =>'#E2AD3B',
            'conf_title_color' =>'#BF5C00',
            'conf_border_color' => '#5C110F',
            'conf_title_font_color' => '#FCD771',
            'conf_files_font_color' => '#901811',
            'conf_toolbar_color' => '#901811');
        //Sunny
        $colors['sunny'] = array(
            'conf_background' =>'#FCF7BE',
            'conf_main_color' =>'#FEF28F',
            'conf_title_color' =>'#FFDA39',
            'conf_border_color' => '#EFDA39',
            'conf_title_font_color' =>'#DD4F08',
            'conf_files_font_color' => '#FCF7BE',
            'conf_toolbar_color' => '#EF9846');
        //ice
        $colors['ice'] = array(
            'conf_background' =>'#E3E6E9',
            'conf_main_color' =>'#D3E1EC',
            'conf_title_color' =>'#BDD0E0',
            'conf_border_color' => '#648DAF',
            'conf_title_font_color' => '#097CDA',
            'conf_files_font_color' => '#E3E6E9',
            'conf_toolbar_color' => '#1A4E78');

        $options = (array) $this->getOptions();
        ob_start();
        include 'colorschemelist.template.php';
        $content = ob_get_contents();
        ob_end_clean();

        return $content;
    }
}
