<?php
namespace LMS\Tools\Announcements\Controllers;

defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Announcement extends Base\Controller
{
    public function __construct($config=array())
    {
        parent::__construct($config);
        $this->input->set('view', 'announcement');

    }

    public function display($cachable=false, $urlparams=array())
    {

        $course_id =(int) $this->input->get('course_id', 0);
        $id = (int) $this->input->getInt('id');
        $model = $this->getModel('Announcement');

        $pathway = array();
        $pathway[] = array('name' => _JLMS_TOOLBAR_AGENDA, 'link' => sefRelToAbs("index.php?option=com_joomla_lms&amp;&amp;task=attendance&amp;id=". $course_id), 'is_home' => false);
        JLMSAppendPathWay($pathway);

        $model->setState('announcement.id', $id);
        $model->setState('announcement.course_id', $course_id);

        $view = $this->getView('Announcement');
        $view->setModel($model, true);
        $view->course_id = $course_id;
        $view->dateHandler = ServiceLocator::get('date_handler');
        $view->display();
    }

    public function add()
    {
        $this->edit();
    }

    public function edit($key = null, $urlVar = 'id')
    {
        $course_id = $this->input->get('course_id', 0);
        $cid = $this->input->get('cid', array(), 'array');
        $id = (int) (count($cid) ? $cid[0] : $this->input->getInt($urlVar));

        $pathway = array();
        $pathway[] = array('name' => _JLMS_TOOLBAR_AGENDA, 'link' => sefRelToAbs("index.php?option=com_joomla_lms&amp;&amp;task=attendance&amp;id=". $course_id), 'is_home' => false);
        JLMSAppendPathWay($pathway);
        
        $model = $this->getModel('announcement');

        $model->setState('announcement.course_id', $course_id);
        $model->setState('announcement.id', $id);

        $view = $this->getView('Announcement');
        $view->setModel($model, true);
        $view->dateHandler = ServiceLocator::get('date_handler');
        $view->course_id = $course_id;

        $view->editItem();
    }

    public function cancel()
    {
        $jform_data = $this->input->get('jform', array(), 'array');
        $course_id = (int)$jform_data['course_id'];

        $link = 'index.php?option=com_joomla_lms&task=announcements';
        $link .= '&course_id='.$course_id;

        $link = \JRoute::_($link, false);
        $link = html_entity_decode($link);

        $this->setRedirect($link);
    }

    public function save()
    {
        $task = $this->input->get('task', 'save');
        $jform_data = $this->input->get('jform', array(), 'array');
        $course_id = (int)$jform_data['course_id'];

        $model = $this->getModel('Announcement');
        $lastInsertID = $model->save($jform_data);

        if($task == 'apply'){
            $link = 'index.php?option=com_joomla_lms&task=announcements.announcement.edit';
            $link .= '&id='.$lastInsertID;
            $link .= '&course_id='.$course_id;
        } else
            if($task == 'save2new'){
                $link = 'index.php?option=com_joomla_lms&task=announcements.announcement.edit';
                $link .= '&course_id='.$course_id;
            } else {
                $link = 'index.php?option=com_joomla_lms&task=announcements';
                $link .= '&course_id='.$course_id;
            }

        $link = \JRoute::_($link, false);
        $link = html_entity_decode($link);

        $this->setRedirect($link);
    }

    public function apply()
    {
        $this->save();
    }

    public function save2new()
    {
        $this->save();
    }

    public function delete()
    {
        $course_id = $this->input->get('course_id', 0);
        $aid = $this->input->get('id', 0);

        $model = $this->getModel('Announcement');
        $model->deleteItem($aid);

        $link = 'index.php?option=com_joomla_lms&task=announcements';
        $link .= '&course_id='.$course_id;

        $link = \JRoute::_($link, false);
        $link = html_entity_decode($link);

        $this->setRedirect($link);
    }
}