<?php
namespace LMS\Tools\Coursebuilder\Controllers;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class LearningPattern extends Base\Controller
{
	public function __construct($config=array())
	{
		parent::__construct($config);
	}

	public function show()
	{
		$Itemid = $this->input->get('Itemid', 0);
		$courseId = $this->input->get('course_id', 0);
		$patternId = $this->input->get('pattern_id', 0);
		$reset = $this->input->get('reset', 0);

		$modelLearningPattern = $this->getModel('LearningPattern');
		$modelLearningPattern->setState('courseId', $courseId);
		$modelLearningPattern->setState('patternId', $patternId);
		$modelLearningPattern->setState('reset', $reset);
		$this->populateModel($modelLearningPattern);

		$view = $this->getView('LearningPattern');
		$view->setModel($modelLearningPattern, true);
		if($Itemid){ $view->Itemid = $Itemid; }

		$view->show();
	}

	public function save()
	{
		$Itemid = $this->input->get('Itemid', 0);
		$courseId = $this->input->get('course_id', 0);
		$patternId = $this->input->get('pattern_id', 0);
		$teacherCid = $this->input->get('teacherCid', array(), 'array');
		$learnerCid = $this->input->get('learnerCid', array(), 'array');

		$modelLearningPattern = $this->getModel('LearningPattern');
		$modelLearningPattern->setState('courseId', $courseId);
		$modelLearningPattern->setState('patternId', $patternId);
		$modelLearningPattern->setState('teacherCid', $teacherCid);
		$modelLearningPattern->setState('learnerCid', $learnerCid);

		$modelLearningPattern->save();

		/*
		$savedPatternId = $modelLearningPattern->getSavedPatternId();
		$allowedSaveModules = 1;
		if($savedPatternId == $patternId){
			$allowedSaveModules = 0;
		}

		$modelLearningPattern->saveProhibitedTools();

		$modelModule = $this->getModel('Module');
		$modelModule->setState('courseId', $courseId);

		$pattern = $modelLearningPattern->getPatternById($patternId);

		if($allowedSaveModules && isset($pattern->modules) && is_array($pattern->modules)){
			$modelModule->saveModulesPattern($pattern->modules);
		}
		*/

//		$link = 'index.php?option=com_joomla_lms&task=coursebuilder.learningpattern.show';
		$link = 'index.php?option=com_joomla_lms&task=coursebuilder.builder.show';
		$link .= '&step=5';
		$link .= '&course_id='.$courseId;
		$link .= '&Itemid='.$Itemid;

		$this->setRedirect(\JLMSRoute::_($link));
	}

	public function reset()
	{
		$Itemid = $this->input->get('Itemid', 0);
		$courseId = $this->input->get('course_id', 0);
		$reset = $this->input->get('reset', 1);
		$patternId = $this->input->get('pattern_id', 0);

		$modelLearningPattern = $this->getModel('LearningPattern');
		$modelLearningPattern->setState('courseId', $courseId);

		$modelLearningPattern->deleteProhibitedToolsForCourse();

		$modelModule = $this->getModel('Module');
		$modelModule->setState('courseId', $courseId);

		$modelModule->deleteModulesPattern();

		$modelLearningPattern->updateCourseParams();

//		$link = 'index.php?option=com_joomla_lms&task=coursebuilder.learningpattern.show';
		$link = 'index.php?option=com_joomla_lms&task=coursebuilder.builder.show';
		$link .= '&step=4';
		$link .= '&course_id='.$courseId;
		$link .= '&reset='.$reset;
		if($reset){
			$link .= '&pattern_id='.$patternId;
		}
		$link .= '&Itemid='.$Itemid;

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}
}