<?php
namespace LMS\Tools\Courses\Controllers;

defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;
use LMS\Tools\Courses\Helpers;

class Images extends Base\Controller
{
	protected $modelModule;	
	
	protected $courseId;

	private $fileFilter = '[\.jpg|\.jpeg|\.gif|\.png]+$';
	
	private $allowedMime = array( 'image/png', 'image/gif', 'image/jpeg', 'image/pjpeg' );	
	
	public function __construct($config=array())
	{
		parent::__construct($config);
		
		$this->doc = ServiceLocator::get('doc');
		$this->repCourse = ServiceLocator::get('course_rep');		
				
		$this->courseId = $this->input->getInt('course_id');		
		
		\jimport('joomla.filesystem.file');
		\jimport('joomla.filesystem.folder');		

		if (!$this->user->get('id'))
		{			
			die('permissions error');
		}	
	}
	
	function thumb() 
	{
		$filename = $this->input->get('file', '', 'RAW');
		$folder = $this->input->get('folder', 'default', 'RAW');
		$userId = $this->input->get('folderid', 0);
		
		if(!$this->user->get('isRoot') && $userId != $this->user->get('id')) 
		{
			die('0');
		}		

		if ( !preg_match('/'. $this->fileFilter .'/', $filename) || !\JFolder::exists(Helpers\Images::folderPath($folder, $userId)) || !\JFile::exists(Helpers\Images::filePath($filename, $folder, $userId)) ) {
			die('permissions error');
		}		

		$this->showThumb(Helpers\Images::filePath($filename, $folder, $userId));
	}
	
	function upload() 
	{
		$result = array();
		
		$folder = $this->input->get('folder', 'default', 'RAW');
		$userId = $this->input->getInt('folderid', 0);	
		
		if(!$this->user->get('isRoot') && $userId != $this->user->get('id')) 
		{
			die('permissions error');
		}		
		
		$defFolder = \JFolder::files(JPATH_COMPONENT.DS.'assets'.DS.'userdefault');						
		
		if ( Helpers\Images::userDir($userId, $folder) )
		{
			foreach ($_FILES['files']['name'] as $k => $filename)
			{
				if ( in_array($_FILES['files']['type'][$k], $this->allowedMime) )
				{
					$info = pathinfo($filename);
					
					if(is_array($defFolder) && in_array($filename, $defFolder)) 
					{
						$file = $filename;
					} else {
						$file = md5(time().rand(10, 99).$userId.$filename).'.'.$info['extension'];
					}
					

					$uploadResult = \JFile::upload( $_FILES['files']['tmp_name'][$k], Helpers\Images::filePath($file, $folder, $userId) );

					if ( $uploadResult )
					{				
						$result[] = array(
							'name' => $filename,
							'size' => $_FILES['files']['size'][$k],
							'type' => $_FILES['files']['type'][$k],
							'deleteUrl' => \JURI::root() . 'index.php?option=com_joomla_lms&task=courses.images.delete&file='.urlencode($filename).'&folder='.$folder.'&folderid='.$userId.'&course_id='.$this->courseId,
						);
					}
					else
					{
						print_r(\JError::getErrors());
					}
				}
			}
		}

		$this->doc->setMimeEncoding( 'application/json' );
		echo json_encode( array('files'=> $result) );
		exit();
	}
	
	function delete() 
	{
		$folder = $this->input->get('folder', 'default', 'RAW');
		$userId = $this->input->getInt('folderid', 0);
		
		if(!$this->user->get('isRoot') && $userId != $this->user->get('id')) 
		{
			die('permissions error');
		}
		
		$filename = $this->input->get('file', '', 'RAW');	

		if ( !empty($filename) && Helpers\Images::userDir($userId, $folder) )
		{
			\JFile::delete(Helpers\Images::filePath($filename, $folder, $userId));			
		}

		die('1');		
	}
	
	function show() 
	{
		$folder = $this->input->get('folder', 'default', 'RAW');
		$userId = $this->input->getInt('folderid', 0);
		
		$result = array();
				
		if(!$this->user->get('isRoot') && $userId != $this->user->get('id')) 
		{
			die('permissions error');
		}		
		
		$folderPath = Helpers\Images::folderPath($folder, $userId);		
		
		if(!$folderPath) 
		{
			die('0');
		}
		
		$myFolder = \JFolder::files($folderPath, $this->fileFilter );		
				
		if ( !empty($myFolder) )
		{
			foreach ($myFolder as $file)
			{
				$result[] = array(					
					'image' => Helpers\Images::fileUrl($file, $folder, $userId),
					'thumb' => \JURI::root() . 'index.php?option=com_joomla_lms&task=courses.images.thumb&folder='.$folder.'&folderid='.$userId.'&file='.urlencode($file),
					'folder' => $folder
				);
			}
		}
		else
		{
			$result[] = array(
				'image' => '',
				'thumb' => '',
				'folder' => $folder
			);
		}
		
		$this->doc->setMimeEncoding( 'application/json' );
		echo json_encode($result);
		exit();

		break;
	}	

	// generating thumbnail and show it
	function showThumb($file, $th_width = 110, $th_height = 110)
	{		
		ob_clean();
		
		require_once(JPATH_ROOT.DS.'components'.DS.'com_joomla_lms'.DS.'tools'.DS.'courses'.DS.'assets'.DS.'ckeditor'.DS.'itb.php');
		$Itb = new \Image_Toolbox($file);
		$Itb->newOutputSize((int)$th_width, (int)$th_height, 4);		
		$Itb->output(3);		
		exit;
	}
}