<?php
namespace LMS\Tools\Courses\Helpers;

defined('_JEXEC') or die;

use LMS\Libraries\ServiceLocator;

defined('JLMS_IMAGES_FOLDER') or define('JLMS_IMAGES_FOLDER', 'usersdata');

$config = ServiceLocator::get('config');
$tmpFolder = $config->get('temp_folder', 'jlms');

defined('JLMS_IMAGES_BASE_URL_REL') or define('JLMS_IMAGES_BASE_URL_REL', $tmpFolder.'/'.JLMS_IMAGES_FOLDER.'/');
defined('JLMS_IMAGES_BASE_DIR') or define('JLMS_IMAGES_BASE_DIR', JPATH_ROOT.DS.$tmpFolder.DS.JLMS_IMAGES_FOLDER.DS);
defined('JLMS_IMAGES_BASE_URL') or define('JLMS_IMAGES_BASE_URL', \JURI::root().$tmpFolder.'/'.JLMS_IMAGES_FOLDER.'/');

class Images
{		
	public static $folder = JLMS_IMAGES_FOLDER;	
	public static $baseDir = JLMS_IMAGES_BASE_DIR;	
	public static $baseUrlRel = JLMS_IMAGES_BASE_URL_REL;	
	public static $baseUrl = JLMS_IMAGES_BASE_URL;
	
	public static function userUrl($userId)
	{		
		return self::$baseUrl.$userId.'/';
	}
		
	public static function userDir($userId)
	{				
		return self::$baseDir.$userId.DS;
	}	
	
	public static function fileUrlRel($filename, $folder, $userId)
	{		
		return self::$baseUrlRel.$userId.'/'.$folder.'/'.$filename;
	}
	
	public static function fileUrl($filename, $folder, $userId)
	{		
		return self::userUrl($userId).$folder.'/'.$filename;
	}
	
	public static function filePath($filename, $folder, $userId)
	{		
		return self::userDir($userId).$folder.DS.$filename;
	}	
	
	public static function folderPath($folder, $userId)
	{		
		return self::userDir($userId).$folder.DS;
	}
}
