<?php
  
namespace LMS\Tools\Courses\Model;
 
defined('_JEXEC') or die;

use LMS\Tools\Courses\Repositories as Rep;
use LMS\Libraries;
use LMS\Libraries\Base;

class Course extends Base\Model
{	
	var $context = 'mailbox';
	
	var $modelDir = __DIR__;
	
	public function __construct($options = array())
	{		
		$this->repository = new Rep\Course();
		
		parent::__construct($options);
	}	

	public function getForm($data = array(), $loadData = true)
	{
		// Get the form.
		$form = $this->loadForm('com_joomla_lms.course', 'course', array('control' => 'courseform', 'load_data' => $loadData));
		
		if (empty($form))
		{
			return false;
		}

		return $form;
	}
	
	public function save($data)
	{	
		$this->repository->save($data);		
	}
	
	protected function loadFormData()
	{
		$courseId = $this->getState('course_id');		
		
		$data = $this->repository->getByID($courseId);		
		
		return $data;
	}
}
