<?php
namespace LMS\Tools\Homework\Model;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;
use LMS\Tools\Homework\Repositories;

defined('_JEXEC') or die;


class Homeworks extends Base\Model
{
	protected $name = 'Homeworks';

	public function __construct($options)
	{
		parent::__construct($options);
		$this->modelDir = __DIR__;
		$this->repository = isset($options['repository']) ? $options['repository'] : new Repositories\Homework(array('db' => ServiceLocator::get('db')));
	}

    public function getItemsForTeacher()
    {
		$items = parent::getItems();

		$homeworkResultsRepository = new Repositories\HomeworkResults();

		foreach($items as $item){
			$results = $homeworkResultsRepository->getByFilter(
				array(
					'courseId' => $this->getState('courseId'),
					'homeworkId' => $item->id,
					'homeworkStatus' => 1,
				)
			);

			$item->quantityMarked = 0;
			if(isset($items) && count($results)){
				$item->quantityMarked = count($results);
			}
		}

		return $items;
	}

	public function getItemsForLearner()
	{
		$items = parent::getItems();

//		echo '<pre>';
//		print_r($items);
//		echo '</pre>';

		foreach($items as $item){

//			echo '<pre>';
//			print_r($item->homeworkResults);
//			echo '</pre>';

			if(isset($item->homeworkResults) && is_array($item->homeworkResults) && count($item->homeworkResults) && $this->getState('userId')){
				$results = $item->getHomeworkResults(
					array(
						'user_id' => $this->getState('userId')
					)
				);
				if(isset($results[0])){
					$item->result = $results[0];
				}
			}
		}

		return $items;
	}

	public function publish(&$pks, $value = 1)
	{
		foreach($pks as $pk){
			$data = array();
			$data['published'] = $value;

			$conditions = array();
			$conditions['id'] = $pk;

			$this->repository->update($data, $conditions);
		}
		return true;
	}

	public function saveorder($pks = null, $order = null)
	{
		foreach ($pks as $i => $pk)
		{
			$item = $this->repository->getByID((int) $pk);
			if($item->ordering != $order[$i]){
				$data = array();
				$data['ordering'] = $order[$i];

				$conditions = array();
				$conditions['id'] = $pk;

				$this->repository->update($data, $conditions);
			}
		}
		return true;
	}

}