<?php

defined('JPATH_PLATFORM') or die;

JFormHelper::loadFieldClass('file');

use LMS\Libraries\ServiceLocator;

class JFormFieldExtFile extends JFormFieldFile
{
	protected function getInput()
	{
		// Initialize some field attributes.
		$accept    = !empty($this->accept) ? ' accept="' . $this->accept . '"' : '';
		$size      = !empty($this->size) ? ' size="' . $this->size . '"' : '';
		$class     = !empty($this->class) ? ' class="' . $this->class . '"' : '';
		$disabled  = $this->disabled ? ' disabled' : '';
		$required  = $this->required ? ' required aria-required="true"' : '';
		$autofocus = $this->autofocus ? ' autofocus' : '';
		$multiple  = $this->multiple ? ' multiple' : '';

		// Initialize JavaScript field attributes.
		$onchange = $this->onchange ? ' onchange="' . $this->onchange . '"' : '';

		// Including fallback code for HTML5 non supported browsers.
		JHtml::_('jquery.framework');
		JHtml::_('script', 'system/html5fallback.js', false, true);		
		
		return '<input type="file" name="' . $this->name . '" id="' . $this->id . '" value="'.$this->getFileName('value').'"' . $accept
			. $disabled . $class . $size . $onchange . $required . $autofocus . $multiple . ' />';
	}
	
	public function __get($name)
	{			
		switch ($name)
		{			
			case 'fileName':				
				return $this->getFileName($this->value);
			default:
				return parent::__get($name);
		}	
	}	
	
	protected function getFileName($value)
	{	
		if(!$value){
			return '';
		}
		
		$fileRep	= ServiceLocator::get('file_rep');		
		$fileData = $fileRep->getById($value);
		
		if($fileData) {
			return $fileData->file_name;
		} else {
			return '';
		}
	}
}
