<?php
namespace LMS\Tools\Subscriptions\Controllers;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Subscription extends Base\Controller
{
	protected $modelModule;
	
	public function __construct($config=array())
	{			
		parent::__construct($config);
	}
	
	public function add($config=array())
	{			
		if(!$this->user->get('id')) {
			$this->setRedirect(\JLMSRoute::_('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}	
		
		$data		= $this->input->get('jform', array(), 'array');
		$redirect	= $this->input->getVar('redirect', '');
		$courseId	= $this->input->getInt('course_id', 0);		
		
		$model = $this->getModel('subscription');
		
		$form = $model->getForm('subscription');
		
		$validate = $model->validate($form, $data);
		
		if ($validate === false)
		{
			// Get the validation messages.
			$errors	= $model->getErrors();

			// Push up to three validation messages out to the user.
			for ($i = 0, $n = count($errors); $i < $n && $i < 3; $i++)
			{
				if ($errors[$i] instanceof Exception)
				{
					$this->application->enqueueMessage($errors[$i]->getMessage(), 'warning');
				}
				else
				{
					$this->application->enqueueMessage($errors[$i], 'warning');
				}
			}

			// Save the data in the session.			
			$this->application->setUserState('com_joomla_lms.subscription.data', $data);

			// Redirect back to the contact form.
			$this->setRedirect(\JLMSRoute::_('index.php?option=com_joomla_lms&task=coursebuilder.builder.show&step=3&wdf=1&course_id=' . $courseId));

			return false;
		}

		
		$model->setState('course_id', $courseId);
		
		$model->save($data);
		
		if($redirect) {			
			$this->setRedirect(base64_decode($redirect));
		}		
	}
	
	public function delete($config=array())
	{	
		if(!$this->user->get('id')) {
			$this->setRedirect(\JLMSRoute::_('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}
		
		$redirect = $this->input->getVar('redirect', '');
		
		$model	= $this->getModel('subscription');		
		
		$model->delete($this->input->getInt('id', 0));
		
		if($redirect) {
			$this->setRedirect(\JLMSRoute::_(base64_decode($redirect)));
		}		
	}
}